﻿Imports System.IO
Imports System.Data
Imports ClosedXML.Excel
Imports System.Net.Mail
Imports System.Configuration
Imports System.Data.SqlClient
Partial Class VB
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        If Not Me.IsPostBack Then
            GridView1.DataSource = Me.GetData()
            GridView1.DataBind()
        End If
    End Sub

    Private Function GetData() As DataTable
        Dim constr As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
        Using con As New SqlConnection(constr)
            Using cmd As New SqlCommand("SELECT * FROM Customers")
                Using sda As New SqlDataAdapter()
                    cmd.Connection = con
                    sda.SelectCommand = cmd
                    Using dt As New DataTable()
                        sda.Fill(dt)
                        Return dt
                    End Using
                End Using
            End Using
        End Using
    End Function

    Protected Sub ExportExcel(sender As Object, e As EventArgs)
        'Get the GridView Data from database.
        Dim dt As DataTable = GetData()

        'Set DataTable Name which will be the name of Excel Sheet.
        dt.TableName = "GridView_Data"

        'Create a New Workbook.
        Using wb As New XLWorkbook()
            'Add the DataTable as Excel Worksheet.
            wb.Worksheets.Add(dt)

            Using memoryStream As New MemoryStream()
                'Save the Excel Workbook to MemoryStream.
                wb.SaveAs(memoryStream)

                'Convert MemoryStream to Byte array.
                Dim bytes As Byte() = memoryStream.ToArray()
                memoryStream.Close()

                'Send Email with Excel attachment.
                Using mm As New MailMessage("sender@gmail.com", "recipient@gmail.com")
                    mm.Subject = "GridView Exported Excel"
                    mm.Body = "GridView Exported Excel Attachment"

                    'Add Byte array as Attachment.
                    mm.Attachments.Add(New Attachment(New MemoryStream(bytes), "GridView.xlsx"))
                    mm.IsBodyHtml = True
                    Dim smtp As New SmtpClient()
                    smtp.Host = "smtp.gmail.com"
                    smtp.EnableSsl = True
                    Dim credentials As New System.Net.NetworkCredential()
                    credentials.UserName = "sender@gmail.com"
                    credentials.Password = "<password>"
                    smtp.UseDefaultCredentials = True
                    smtp.Credentials = credentials
                    smtp.Port = 587
                    smtp.Send(mm)
                End Using
            End Using
        End Using
    End Sub
End Class
